#include "basic_module.h"


using user::basic_module;

/**
 * Constructor
 */
basic_module::basic_module() {
  debug_level = 9;
}

/** 
 * Sets the value of the internal variable that allows us to print at
 * different levels of verbosity automatically
 */
void basic_module::set_debug_level(unsigned int new_debug_level) {
  debug_level = new_debug_level;
}



/**
 * Prints a message only if its level of importance is above the
 * current debug level.
 */
void basic_module::dprint(unsigned int level, const char* format, ...) const {
  va_list arg_list;
  
  va_start(arg_list, format); // initialize the vararg list
  
  if (debug_level >= level) {
    cout << sc_time_stamp() << " " << sc_delta_count();
    for (unsigned int i=0; i<level; i++)
      printf(" ");

    vprintf(format, arg_list);
  }

  va_end(arg_list); //clean up
}


