#ifndef BASIC_SLAVE_H
#define BASIC_SLAVE_H

#include <systemc.h>
#include "tlm.h"
#include "basic_protocol.h"
#include "basic_module.h"

using tlm::tlm_nonblocking_get_if;
using basic_protocol::basic_request;

namespace user {

template< typename TRANS, typename PAYLD >
  class basic_slave : 
    public sc_module,
    virtual public basic_module {
    
  public: 

    sc_port<
      tlm_nonblocking_get_if <
        basic_request<TRANS,PAYLD>
      >
    > in_port;

    // The constructor
    basic_slave(sc_module_name module_name) : 
      sc_module(module_name),
      in_port("in_port") {
    }

  }; // basic_slave
}; //namespace

#endif
