#ifdef PROPERTY_1

#include "property1.h"


unsigned int property1::unique_id = 0;

/**
 * The constructor
 */
property1::property1(mon_observer* obs, airline::flight_planner* o1) : mon_prototype() {
  observer = obs;
  object1 = o1;
  my_id = unique_id++;

  
  // Register directly with the event
  printf("Property1 (instance %d): Registering the property %s\n", my_id, to_string());
  observer->register_monitor(this, &(object1->conn_queue_nonfull));
  printf("Property 1 (instance %d) has been registered\n", my_id);
}


void 
property1::callback_event_notified(sc_event* e) {

#ifdef PROPERTY_1_VERBOSE
  printf("Verifying %s (instance %d)\n", to_string(), my_id);
#endif

  assert(object1->connectivity_requests.size() < object1->queue_size);

}
 
  
const char*
property1:: to_string() const {
  return "property1: connectivity_requests.size() < queue_size";
}


#endif
