#ifndef PROPERTY_2_H
#define PROPERTY_2_H

#include <systemc>
#include <map>
#include <string>

using namespace sc_core;

typedef std::map< int, sc_time > misc_time;
typedef std::map< int, std::string > mistring;

class property2 : public mon_prototype {

 public:
  // Constructor
  property2(mon_observer* obs);
  
  // Notification that a transaction is entering into the io_module
  void io_module_receive_transaction(int transaction_id);

  // Transaction was sent to the master_module
  void io_module_send_to_master(int transaction_id);
  void io_module_receive_from_master(int transaction_id);

  void master_receive_request_from_io(int transaction_id);
  void master_send_to_flight_planner(int transaction_id);
  void flight_planner_receive_request_from_master(int transaction_id);
  void flight_planner_send_request_to_master(int transaction_id);
  void master_receive_request_from_flight_planner(int transaction_id);
  void master_send_request_to_io_module(int transaction_id);

  virtual void callback_timed_notify_phase_end();
  virtual const char* to_string() const;

 protected:
  mon_observer* observer;
  misc_time requesttime;

#ifdef PROPERTY_2_VERBOSE  
  mistring requestmodule;
#endif 
  sc_time max_allowed_delay;
  sc_time max_allowed_deadtime;
  

  void print_request_summary();

 private:
  static unsigned int unique_id;
  unsigned int my_id;

}; // property2

#endif
